// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	"LAPP_ACURA_MOM_BACKEND/grmi"
	meta "LAPP_ACURA_MOM_BACKEND/meta/base"
	model "LAPP_ACURA_MOM_BACKEND/models/base"
	"github.com/go-xorm/xorm"
	"xorm.io/core"
)

/******************************************************************************
 *
 * @Struct Name              : AndonInfoDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : AndonInfo的数据访问对象实现
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2022-01-06 14:56:42
 *
 ******************************************************************************/
type AndonInfoDAOImplement struct {
	session *xorm.Session
	meta    *grmi.Entity
	userid  string
}

/******************************************************************************
 *
 * @Function Name            : NewAndonInfoDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个AndonInfoDAOImplement实例
 *
 * @Function Parameters      : xorm会话
 *

 * @Return Value             : AndonInfoDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2022-01-06 14:56:42
 *
 ******************************************************************************/
func NewAndonInfoDAOImplement(session *xorm.Session, userid string) *AndonInfoDAOImplement {
	return &AndonInfoDAOImplement{session, &meta.AndonInfo, userid}
}

/******************************************************************************
 *
 * @Reference leit.com/LAPP_ACURA_MOM_BACKEND/dao/base/AndonInfoDAO.InsertOne
 *
 ******************************************************************************/
func (impl *AndonInfoDAOImplement) InsertOne(entity *model.AndonInfo) error {

	_, err := impl.session.Table(impl.meta.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference leit.com/LAPP_ACURA_MOM_BACKEND/dao/base/AndonInfoDAO.DeleteOne
 *
 ******************************************************************************/
func (impl *AndonInfoDAOImplement) DeleteOne() error {
	_, err := impl.session.Table(impl.meta.TableName).ID(core.PK{}).Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

/******************************************************************************
 *
 * @Reference leit.com/LAPP_ACURA_MOM_BACKEND/dao/base/AndonInfoDAO.SelectOne
 *
 ******************************************************************************/
func (impl *AndonInfoDAOImplement) SelectOne() (*model.AndonInfo, error) {
	var data model.AndonInfo
	ok, err := impl.session.Table(impl.meta.TableName).ID(core.PK{}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

/******************************************************************************
 *
 * @Reference leit.com/LAPP_ACURA_MOM_BACKEND/dao/base/AndonInfoDAO.UpdateOne
 *
 ******************************************************************************/
func (impl *AndonInfoDAOImplement) UpdateOne(entity *model.AndonInfo) error {

	_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference leit.com/LAPP_ACURA_MOM_BACKEND/dao/base/AndonInfoDAO.Insert
 *
 ******************************************************************************/
func (impl *AndonInfoDAOImplement) Insert(entities *[]model.AndonInfo) error {
	_, err := impl.session.Table(impl.meta.TableName).Insert(entities)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference leit.com/LAPP_ACURA_MOM_BACKEND/dao/base/AndonInfoDAO.Delete
 *
 ******************************************************************************/
func (impl *AndonInfoDAOImplement) Delete(entities *[]model.AndonInfo) error {
	for _, entity := range *entities {

		_, err := impl.session.Table(impl.meta.TableName).ID(entity.GetKey()).Delete(impl.meta.Indicator)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference leit.com/LAPP_ACURA_MOM_BACKEND/dao/base/AndonInfoDAO.DeleteWhere
 *
 ******************************************************************************/
func (impl *AndonInfoDAOImplement) DeleteWhere(predicates []grmi.Predicate) error {

	parameters := []interface{}{}
	where := "1 = 1 "

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := session.Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference leit.com/LAPP_ACURA_MOM_BACKEND/dao/base/AndonInfoDAO.Select
 *
 ******************************************************************************/
func (impl *AndonInfoDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.AndonInfo, error) {

	parameters := []interface{}{}
	where := "1 = 1 "

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.AndonInfo, 0, 10)
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference leit.com/LAPP_ACURA_MOM_BACKEND/dao/base/AndonInfoDAO.SelectCols
 *
 ******************************************************************************/
func (impl *AndonInfoDAOImplement) SelectCols(predicates []grmi.Predicate, orderByFields []grmi.Field, cloumns []string) ([]map[string]interface{}, error) {

	parameters := []interface{}{}
	where := "1 = 1 "

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]map[string]interface{}, 0, 10)
	err := session.Cols(cloumns...).Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference leit.com/LAPP_ACURA_MOM_BACKEND/dao/base/AndonInfoDAO.SelectAndPaging
 *
 ******************************************************************************/
func (impl *AndonInfoDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {

	parameters := []interface{}{}
	where := "1 = 1 "

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	count, err := session.Count(impl.meta.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}

	orderBy := " order by "
	if orderByFields != nil {
		for _, field := range orderByFields {
			if orderBy == " order by " {
				orderBy += field.ColumnName
			} else {
				orderBy += ", " + field.ColumnName
			}
		}
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.AndonInfo, 0, 10)
	where = " where " + where
	err = impl.session.Table(impl.meta.TableName).SQL("select * from ["+impl.meta.TableName+"]"+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}

/******************************************************************************
 *
 * @Reference leit.com/LAPP_ACURA_MOM_BACKEND/dao/base/AndonInfoDAO.Update
 *
 ******************************************************************************/
func (impl *AndonInfoDAOImplement) Update(entities *[]model.AndonInfo) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]

		_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference leit.com/LAPP_ACURA_MOM_BACKEND/dao/base/AndonInfoDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *AndonInfoDAOImplement) UpdateWhere(predicates []grmi.Predicate, entity *model.AndonInfo, columns ...string) error {

	parameters := []interface{}{}
	where := "1 = 1 "

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	columns = append(columns, meta.AndonInfo_LastUser.Name)
	_, err := impl.session.Table(impl.meta.TableName).Cols(columns...).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}
